{ pkgs ? import <nixpkgs> {}
, withPython ? true
, withOCaml ? true
, withRust ? false
}:

with pkgs;

mkShell {

  packages =
  [ jasmin-compiler ]
  ++ lib.optional withPython python3
  ++ lib.optional withRust rustc
  ++ lib.optionals withOCaml (with ocamlPackages; [
    ocaml findlib ctypes
  ])
  ;

  shellHook = ''
    export JASMINPATH=AES=$PWD/src/aeslib
  '';

}
